auth_ssl_username_from_cert = yes
listen = *
log_timestamp = "%Y-%m-%d %H:%M:%S "
mail_debug = yes
mail_location = maildir:~/var/mail:INDEX=/var/lib/dovecot-index/%u:CONTROL=/var/lib/dovecot-control/%u
# NOTE: INDEX et CONTROL sont sur une partition sans quota comme le demande la doc
# VOIR: http://wiki2.dovecot.org/Quota/FS
mail_plugins = $mail_plugins quota
mail_privileged_group = mail
passdb {
	args = /home/%u/etc/dovecot/passwd
	driver = passwd-file
 }
plugin {
	quota = fs:user
	recipient_delimiter = +
	sieve = ~/etc/mail/filter.sieve
	sieve_dir = ~/etc/mail/sieve
	sieve_global_dir = /var/lib/dovecot/sieve/global/
	sieve_max_script_size = 1M
	sieve_quota_max_scripts = 0
	sieve_quota_max_storage = 10M
	sieve_user_log = ~/var/log/mail/sieve.log
 }
protocol imap {
	mail_plugins = $mail_plugins imap_quota
 }
protocol lda {
	auth_socket_path = /var/run/dovecot/auth-master
	hostname = LOCAL_DOMAINNAME
	info_log_path =
	log_path =
	mail_plugins = $mail_plugins sieve
	postmaster_address = contact+dovecot+lda@LOCAL_DOMAINNAME
	syslog_facility = mail
 }
protocols = imap sieve
service auth {
	user = root
	unix_listener /var/spool/postfix/private/auth {
		mode  = 0660
		user  = postfix
		group = postfix
	 }
 }
ssl_ca = </etc/dovecot/LOCAL_DOMAINNAME/imap/x509/crt+crl.self-signed.pem
ssl_cert = </etc/dovecot/LOCAL_DOMAINNAME/imap/x509/crt+crl.self-signed.pem
ssl_cipher_list = AES256-SHA
ssl_key = </etc/dovecot/LOCAL_DOMAINNAME/imap/x509/key.pem
ssl_verify_client_cert = yes
userdb {
	driver = passwd
 }
verbose_ssl = no
