"$tool"/local/apt-get-install mysql-server-5.5
"$tool"/local/insserv-remove  mysql

eval "home=~$sv"

"$tool"/local/adduser "$sv" \
 --disabled-login \
 --disabled-password \
 --group \
 --home "$home" \
 --shell /bin/false \
 --system
"$tool"/local/adduser "$sv"-data \
 --disabled-login \
 --disabled-password \
 --group \
 --home "$home"/data \
 --no-create-home \
 --shell /bin/false \
 --system
sudo usermod --home "$home" "$sv"
sudo adduser "$sv" "$sv"-data
sudo install -d -m 755 -o "$sv" -g "$sv" \
 "$home"
sudo rm -rf /etc/mysql
sudo install -d -m 750 -o "$sv" -g "$sv"-data \
 /etc/mysql \
 /etc/mysql/conf.d \
 "$home"/etc
sudo ln -fns \
        /etc/mysql \
 "$home"/etc/mysql
sudo install -m 644 -o "$sv" -g "$sv" \
 "$tool"/etc/mysql/my.cnf \
        /etc/mysql/my.cnf
if sudo test ! -d "$home"/data
 then
	sudo install -d -m 750 -o "$sv" -g "$sv"-data \
	 "$home"/data
	sudo -u "$sv" mysql_install_db \
	 --datadir="$home"/data \
	 --no-defaults
 fi

sudo ln -fns \
        ../sv/"$sv" \
 /etc/service/"$sv"
"$tool"/local/runit-sv-start "$sv"
while ! sudo mysql -u root </dev/null
do sleep 1; done

sudo mysql -u root --batch --verbose <<-EOF
	-- NOTE: supprime le login anonyme
	DELETE FROM mysql.db   WHERE User = '';
	DELETE FROM mysql.user WHERE User = '';
	
	-- NOTE: supprime l'accès par mot-de-passe à root
	DELETE FROM mysql.user WHERE User = 'root' and Plugin = '';
	
	DROP PROCEDURE IF EXISTS mysql.create_super_user;
	DELIMITER //
	CREATE PROCEDURE mysql.create_super_user (username VARCHAR(16), hostname VARCHAR(60))
	 BEGIN
		IF NOT (EXISTS (SELECT User
			FROM mysql.user
			WHERE User = username
			AND   Host = hostname
			LIMIT 1))
		THEN
			SET @QUERY = CONCAT("CREATE USER ", username, "@", hostname, " IDENTIFIED WITH auth_socket");
			PREPARE stmt FROM @QUERY;
			EXECUTE stmt;
		 END IF;
	 END;
	 //
	
	CALL mysql.create_super_user('mysql', 'localhost');
	GRANT ALL PRIVILEGES ON *.* TO 'mysql'@'localhost';
	UPDATE mysql.user SET Grant_priv='Y',Super_priv='Y' WHERE User='mysql';
	
	CALL mysql.create_super_user('backup', 'localhost');
	GRANT EVENT,LOCK TABLES,RELOAD,SELECT,SHOW VIEW ON *.* TO 'backup'@'localhost';
	
	FLUSH PRIVILEGES;
	EOF
sudo adduser backup "$sv"-data
sudo adduser backup "$sv"

sudo find "$tool"/local/backup \
 -mindepth 1 -maxdepth 1 -type f \
 -exec install -m 750 -o backup -g backup \
 -t ~backup/bin {} +
sudo install -m 640 -o root -g root \
 "$tool"/etc/cron.d/mysql-backup \
        /etc/cron.d/mysql-backup
sudo install -m 640 -o root -g root \
 "$tool"/etc/sudoers.d/mysql-backup \
        /etc/sudoers.d/mysql-backup
